#########
## DEM ##
#########

if (!dir.exists("./data/derived_data/")) {
  dir.create("./data/derived_data/")
}

if (!file.exists("./data/derived_data/dem.tif")) {
  system(paste("find",
               "./data/raw_data/TanDEM/",
               "-name '*.tar.gz'",
               "-exec tar -xzf {}",
               "\\;"))
  system(paste("find",
               "dims*/",
               "-type f",
               "-size +100M",
               "-name '*_DEM.tif'",
               "-exec gdal_merge.py -n -32767.0 -o dem.tif {} +"
               ))
  system(paste("mv",
               "dem.tif",
               "data/derived_data/dem.tif"))
  system(paste("rm -rf",
               "dims*/"))
}

if (!file.exists("./data/derived_data/Turkey.gpkg")) {
  turkey <- raster::getData(country = "Turkey", level = 0)
  turkey <- sf::st_as_sf(turkey)
  sf::st_write(turkey,
               dsn = "./data/derived_data/Turkey.gpkg",
               layer = "GADM_Turkey",
               driver = "GPKG")
  file.remove("gadm36_TUR_0_sp.rds")
}

if (!file.exists("data/derived_data/dem_crop.vrt")) {
  system(paste("gdalwarp",
               "-s_srs EPSG:4326",
               "-t_srs EPSG:4326",
               "-cutline data/derived_data/Turkey.gpkg",
               "-cl GADM_Turkey",
               "-crop_to_cutline",
               "-srcnodata -32767.0",
               "-dstnodata -32767.0",
               "data/derived_data/dem.tif",
               "data/derived_data/dem_crop.vrt"))
}

if (!file.exists("data/derived_data/dem_utm.tif")) {
  system(paste("gdalwarp",
               "-s_srs EPSG:4326",
               "-te 26.5 38.8 28.0 39.5",
               "-te_srs EPSG:4326",
               "-tr 10 10",
               "-r cubicspline",
               "-t_srs EPSG:32635",
               "-srcnodata -32767.0",
               "-dstnodata -32767.0",
               "data/derived_data/dem_crop.vrt",
               "data/derived_data/dem_utm.tif"))
}

if (!file.exists("data/derived_data/dem_agg_utm.tif")) {
  system(paste("gdalwarp",
               "-tr 50 50",
               "-r cubicspline",
               "-srcnodata -32767.0",
               "-dstnodata -32767.0",
               "data/derived_data/dem_utm.tif",
               "data/derived_data/dem_agg_utm.tif"))
}

